
/*
 * @(#)ChatServer.java	1.11 97/02/27
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
import webflow.*;
import SharedData.*;
import SharedData.socket.*;


/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     0.90 11 February 1997
 * @author      Rich Burridge
 */

////////////////////////////////////////////////////////////////////////////////////
// This module creates ports for the server in the initialize method,creates a    //
//session and a channel for this session in the run method and destroys the ports //
// in the destroy method.
////////////////////////////////////////////////////////////////////////////////////

 
public class
ChatServer1 implements ChatDebugFlags,Module{
    
    private static Stringobj sessionName;

ChatPort chatport1;
ChatPort chatport2;
ChatClient client;


Session    chatSession ; 
    public MetaModule initialize(){

	 MetaModule mm=new MetaModule("ChatUser");
         chatport2=new ChatPort();
 mm.putPortID(chatport2.getPortID());
chatport1=new ChatPort();
 
         mm.putPortID(chatport1.getPortID());
       
        return(mm);
    }

    public void run() {
 client      = null;
    chatSession = null;
	String     url         = null;
	String     sessionType = null;
	String     hostname    = null;
	int        hostport    = 0;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: main.");
        }
	sessionName=new Stringobj(2);
	sessionName.setstr("ChatSession",0);
	sessionName.setstr("WBSession",1);
        hostname    = "osprey2";//getHost(args);
	hostport    = 8100;//getPort(args);
	sessionType = "socket";//getType(args);
	url = "coll://" + hostname + ":" + hostport + "/" + sessionType +
	      "/Session/" + sessionName.getstr(0);

	try {

/* Create a session, [re]bind it and create a channel. */
 
	    chatSession = SessionFactory.createSession(url);
           System.out.println("Setup and bound Chat server.");
            chatSession.createChannel("ChatChannel", true);	
    		boolean bool=true;
         	          } catch (SharedDataException e) {
            System.out.println("ChatServer: main: shared data exception: " + e);
            if (ChatServer_Debug) {
		e.printStackTrace();
	    }
        } 
}        
    




 
   public void destroy(){
chatport1.destroyPort();
chatport2.destroyPort();
	
     }   
   private static String
    getHost(String args[]) {
        String defHost = "stard";   /* Default host name for connections. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getHost.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-server")) {
                if (++i < length) {
                    return(args[i]);
                }
            }
        }
        return(defHost);
    }

public void stop()
{} 

    private static int
    getPort(String args[]) {
        int defPort = 4461;   /* Default port number for connections. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getPort.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-port")) {
                if (++i < length) {
                    return(Integer.parseInt(args[i]));
                }
            }    
        }
        return(defPort);
    }


    private static String
    getType(String args[]) {
        String defType = "socket";   /* Default Session type. */
        int length = args.length;

        if (ChatServer_Debug) {
            System.out.println("ChatServer: getType.");
        }

        for (int i = 0; i < length; i++) {
            if (args[i].equals("-type")) {
                if (++i < length) {
                    return(args[i]);
                }
            }    
        }
        return(defType);
    }
}





